﻿package packages {
	
	import flash.display.Sprite;
	
	public class Page extends Sprite {
		
		import flash.events.MouseEvent;
		
		import packages.Globals;
		import packages.Picture;
		import packages.Text;
		
		var PageWidth:Number;
		var PageHeight:Number;
		var OffsetX:Number;
		var OffsetY:Number;
		
		//CONSTRUCTOR:
		public function Page(xml:XML, thumb:Boolean = true, H:Number = 0) {
			if (thumb == false) {
				PageHeight = H;
				name = "detailpage";
			} else {
				PageHeight = Globals.THUMB_HEIGHT;
				name = "page" + xml.@NR;
			}
			PageWidth = PageHeight * Globals.PAGE_WIDTH_MM / Globals.PAGE_HEIGHT_MM;
			graphics.lineStyle(1, 0x000000);
			graphics.beginFill(Number("0x" + xml.@PAPERCOLOR));
			graphics.drawRect(0, 0, PageWidth, PageHeight);
			var elemXML:XML;
			for each (elemXML in xml.PICTURE) {
				var picframe:Picture = new Picture(elemXML, thumb, PageWidth / Globals.PAGE_WIDTH_TW, PageHeight / Globals.PAGE_HEIGHT_TW);
				addChild(picframe);
				if (thumb == false) {
					picframe.addEventListener(MouseEvent.MOUSE_DOWN, FrameStartDrag);
					picframe.addEventListener(MouseEvent.MOUSE_UP, FrameStopDrag);
				}
			}
			for each (elemXML in xml.TEXT) {
				var txtframe:Text = new Text(elemXML, thumb, PageWidth / Globals.PAGE_WIDTH_TW, PageHeight / Globals.PAGE_HEIGHT_TW);
				addChild(txtframe);
				if (thumb == false) {
					txtframe.addEventListener(MouseEvent.MOUSE_DOWN, FrameStartDrag);
					txtframe.addEventListener(MouseEvent.MOUSE_UP, FrameStopDrag);
				}
			}
			if (thumb == false) {
				buttonMode = false;
			} else {
				buttonMode = false;
				addEventListener(MouseEvent.MOUSE_OVER, PageOver);
				addEventListener(MouseEvent.MOUSE_OUT, PageOut);
			}
		}
		
		//EVENTS:
		private function PageOver(event:MouseEvent):void { alpha = Globals.ALPHA_VALUE; }
		private function PageOut(event:MouseEvent):void  { alpha = 1; }
		
		private function FrameStartDrag(event:MouseEvent):void {
			OffsetX = event.stageX - event.target.x;
			OffsetY = event.stageY - event.target.y;
			if(getChildIndex(event.target.GetFrame()) != (numChildren - 1)) {
				setChildIndex(event.target.GetFrame(), (numChildren - 1));
			}
			addEventListener(MouseEvent.MOUSE_MOVE, FrameDrag);
		}
		
		private function FrameDrag(event:MouseEvent):void {
			if (event.stageX - OffsetX < 0) {
				event.target.x = 0;
			} else if (event.stageX - OffsetX > PageWidth - event.target.width) {
				event.target.x = PageWidth - event.target.width + 1;
			} else if ((event.stageX - OffsetX >= 0) && (event.stageX - OffsetX <= PageWidth - event.target.width)) {
				event.target.x = event.stageX - OffsetX;
			}
			if (event.stageY - OffsetY < 0) {
				event.target.y = 0;
			} else if (event.stageY - OffsetY > PageHeight - event.target.height) {
				event.target.y = PageHeight - event.target.height + 1;
			} else if ((event.stageY - OffsetY >= 0) && (event.stageY - OffsetY <= PageHeight - event.target.height)) {
				event.target.y = event.stageY - OffsetY;
			}
			event.updateAfterEvent();
		}
		
		private function FrameStopDrag(event:MouseEvent):void {
			removeEventListener(MouseEvent.MOUSE_MOVE, FrameDrag);
			removeEventListener(MouseEvent.MOUSE_OUT, FrameStopDrag);
		}
		
		//ACCESSORS:
		public function GetWidth():Number  { return PageWidth; }
		public function GetHeight():Number { return PageHeight; }
		public function GetPage():Page     { return this; }
		
		//MUTATOR:
		public function SetCoords(X:Number, Y:Number):void { 
			x = X;
			y = Y;
		}
	}
}